/*
© Copyright CERN 2000-2018. All rigths reserved. This software is released under a CERN proprietary software licence.
Any permission to use it shall be granted in writing. Request shall be adressed to CERN through mail-KT@cern.ch
*/

#ifndef LGCGRAPHICALWIDGET_HPP
#define LGCGRAPHICALWIDGET_HPP

#include <editors/script/EditorScriptWidgets.hpp>

class LGCGraphicalWidget : public TabEditorScriptWidget
{
	Q_OBJECT

public:
	LGCGraphicalWidget(SPluginInterface *owner, QWidget *parent = nullptr);
	virtual ~LGCGraphicalWidget() override;

	// SgraphicalWidget
	virtual QString getPath() const override;

public slots:
	// SGraphicalWidget
	virtual void aboutTorun() override
	{
		TabEditorWidget::aboutTorun();
		removeOutputs();
	}
	virtual void runFinished(bool status) override;

protected:
	// SGraphicalWidget
	virtual bool _save(const QString &path) override;
	virtual bool _open(const QString &path) override;
	virtual void _newEmpty() override;
	// STabInterface
	virtual SGraphicalWidget *openOutputFile(SGraphicalWidget *widget, const QString &file, bool checkForOpened = false);

private:
	/** Open the output files generated by LGC and show them if possible */
	void openOutputs(bool onlyLog = false);
	/** Remove the outputs tabs, generally before a new LGC run */
	void removeOutputs();

	/** Setup of entry points - provided they are available. */
	void setupEntryPoints();

	/** Generate HTML report viewer */
	void generateHTMLReport();

private slots:
	/** Jump to a location in the input file pointed to by an indicator. For more information about indicator value refer to @LGCMeasures. */
	void globalIndicatorClicked(const QString &, int indicator);
	void inputHasChanged();

private:
	class _LGCGraphicalWidget_pimpl;
	std::unique_ptr<_LGCGraphicalWidget_pimpl> _pimpl;
};

#endif // LGCGRAPHICALWIDGET_HPP
